[pacman-dev] [PATCH] contrib: adding checkupdates
Kyle Keen
keenerd at gmail.com
Thu Mar 21 17:40:32 EDT 2013
Signed-off-by: Kyle Keen <keenerd at gmail.com>
---
contrib/Makefile.am | 3 +++
contrib/checkupdates.sh.in | 44 ++++++++++++++++++++++++++++++++++++++++++++
2 files changed, 47 insertions(+)
create mode 100644 contrib/checkupdates.sh.in
diff --git a/contrib/Makefile.am b/contrib/Makefile.am
index 64f476c..99baf95 100644
--- a/contrib/Makefile.am
+++ b/contrib/Makefile.am
@@ -6,6 +6,7 @@ bin_SCRIPTS = \
BASHSCRIPTS = \
bacman \
+ checkupdates \
paccache \
pacdiff \
paclist \
@@ -30,6 +31,7 @@ EXTRA_DIST = \
PKGBUILD.vim \
bacman.sh.in \
bash_completion.in \
+ checkupdates.sh.in \
paccache.sh.in \
paclog-pkglist.sh.in \
pacdiff.sh.in \
@@ -93,6 +95,7 @@ uninstall-local:
bacman: $(srcdir)/bacman.sh.in
bash_completion: $(srcdir)/bash_completion.in
+checkupdates: $(srcdir)/checkupdates.sh.in
paccache: $(srcdir)/paccache.sh.in $(top_srcdir)/scripts/library/parseopts.sh $(top_srcdir)/scripts/library/size_to_human.sh
pacdiff: $(srcdir)/pacdiff.sh.in
paclist: $(srcdir)/paclist.sh.in
diff --git a/contrib/checkupdates.sh.in b/contrib/checkupdates.sh.in
new file mode 100644
index 0000000..15950e1
--- /dev/null
+++ b/contrib/checkupdates.sh.in
@@ -0,0 +1,44 @@
+#!/bin/bash
+#
+# checkupdates: Safely print a list of pending updates.
+#
+# Copyright (c) 2013 Kyle Keen <keenerd at gmail.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+if (( $# > 0 )); then
+ echo "checkupdate: Safely print a list of pending updates."
+ echo "Use: checkupdates"
+ echo "Export the 'CHECKUPDATE_DB' variable to change the path of the temporary database."
+ exit 0
+fi
+
+if [[ -z $CHECKUPDATE_DB ]]; then
+ CHECKUPDATE_DB="${TMPDIR:-/tmp}/checkup-db-${USER}/"
+fi
+
+trap 'rm -f $CHECKUPDATE_DB/db.lck' INT TERM EXIT
+
+DBPath="${DBPath:- at localstatedir@/lib/pacman/}"
+eval $(awk -F' *= *' '$1 ~ /DBPath/ { print $1 "=" $2 }' /etc/pacman.conf)
+
+mkdir -p "$CHECKUPDATE_DB"
+ln -s "${DBPath}/local" "$CHECKUPDATE_DB" &> /dev/null
+fakeroot pacman -Sy --dbpath "$CHECKUPDATE_DB" &> /dev/null
+pacman -Qqu --dbpath "$CHECKUPDATE_DB" 2> /dev/null
+
+exit 0
+
+# vim: set ts=2 sw=2 noet:
--
1.8.1.5
More information about the pacman-dev
mailing list